# Generative Adversarial Networks (GANs)

- https://deepart.io/latest/
- https://medium.com/datadriveninvestor/the-infinite-art-machine-3a2decab85d9 (My DC Gan blog post)
- https://github.com/tomguluson92/StyleGAN_PyTorch
- https://magenta.tensorflow.org/gansynth
- https://towardsdatascience.com/cyclegans-to-create-computer-generated-art-161082601709
- https://deepdreamgenerator.com/
- https://www.thispersondoesnotexist.com/
- https://github.com/jantic/DeOldify

# Links to codes I showed today

- https://github.com/SubhadityaMukherjee/animeFaceGenerator
- https://github.com/SubhadityaMukherjee/facegen
- https://github.com/SubhadityaMukherjee/deepDream
- https://github.com/SubhadityaMukherjee/neural_style_transfer

# Where to learn GANs from

Look at the papers I mentioned. Links in the link below

- https://github.com/SubhadityaMukherjee/PaperImplementations (I have written notes about the stuff I explained today. WGAN, DCGAN, VAE etc)
- https://pytorch.org/tutorials/beginner/dcgan_faces_tutorial.html
- https://www.tensorflow.org/tutorials/generative/dcgan
- https://towardsdatascience.com/demystifying-gans-in-tensorflow-2-0-9890834ab3d9
- https://github.com/hindupuravinash/the-gan-zoo
- https://hollobit.github.io/All-About-the-GAN/

# Other Links

- Papers with code - https://paperswithcode.com/
- Experiments - https://experiments.withgoogle.com/
- Implementations - https://github.com/SubhadityaMukherjee/PaperImplementations
- Datasetsearch - https://datasetsearch.research.google.com
- Papers - https://github.com/terryum/awesome-deep-learning-papers#new-papers
- Ai blog - https://ai.googleblog.com/

## Demo

- [Image-to-Image Translation with Conditional Adversarial Nets](https://phillipi.github.io/pix2pix/)
- [Image-to-Image Demo](https://affinelayer.com/pixsrv/) _Interactive Image Translation with pix2pix-tensorflow_

# Courses

- [A to Z ML/DL](https://www.udemy.com/course/machinelearning/)
- [Udemy Deep Learning](https://www.udemy.com/course/deeplearning/)
- [deeplearning.ai](https://www.deeplearning.ai/)
- [Fastai](https://course.fast.ai/)

# Blogs

- [OpenAI](https://www.openai.com/)
- [Distill](http://distill.pub/)
- [Andrej Karpathy Blog](http://karpathy.github.io/)
- [Colah's Blog](http://colah.github.io/)
- [WildML](http://www.wildml.com/)
- [FastML](http://www.fastml.com/)
- [TheMorningPaper](https://blog.acolyer.org/)

### Compiled by

**Subhaditya Mukherjee**

- Email : msubhaditya@gmail.com
- Linkedin : https://www.linkedin.com/in/subhaditya-mukherjee-a36883100
- Github : www.github.com/SubhadityaMukherjee
